Graphics3D 800,600
SetBuffer BackBuffer()
Const TYPE_PLAYER=1,TYPE_TERRAIN=2,TYPE_ROCK=3, TYPE_CAMERA=4, TYPE_BADDY=5, TYPE_NOTHING=0
Const ENDTEXTSIZE=50
Global playerPivot

Global dead

;Global shadow
Global terrain

Global OBJtree, GFXfence, GFXthumb, GFXgate
Global wallcount, treecount, thumbcount,gatecount

Global idiotfont=LoadAnimImage("gfx\idiot.png",40,40,0,100)

Global gtex5,gtex10,gtex25

Global cubez,linez

Type cube ;little cubes.... little... cubes
	Field e,x#,y#,z#,t,gotted,ox#,oy#,oz#
End Type

Type tree
	Field e,x#,y#,z#
End Type
Type fence
	Field e,x#,y#,z#,a
End Type

Type gate
	Field e,x#,y#,z#,a,blox,gotted,ox#,oy#,oz#
End Type

Type thumb
	Field obj,e,x#,y#,z#,fall#,fallspeed#,ox#,oy#,oz#,a
End Type

Type endmessage
	Field message$,y,x#,xx#
End Type

Dim pieces(6,3,3)
Restore pieceDefs
For p=0 To 6
	For y=0 To 3
		For x=0 To 3
			Read pieces(p,x,y)
		Next ;x	
	Next ;y
Next ;p

AppTitle "Tetris Adventure World 3D"

Dim endtext$(ENDTEXTSIZE)
Global textlinenum, textlinecounter, textlineY

setendtext()

;											state=4

Global music=PlayMusic("tetrisnt.xm")
ChannelVolume music,.5
SFXbrick=LoadSound("sfx\brick.ogg")
SFXcrumble=LoadSound("sfx\crumble.ogg")
Global SFXdead=LoadSound("sfx\dead.wav")
SFXjump1=LoadSound("sfx\jump1.ogg")
SFXjump2=LoadSound("sfx\jump2.ogg")
SFXjump3=LoadSound("sfx\jump3.ogg")
SFXscore=LoadSound("sfx\score.ogg")
Global SFXthumb=Load3DSound("sfx\thumb.wav")
SFXDONG=LoadSound("sfx\x.ogg")
SFXghosty=Load3DSound("sfx\ghosty.wav")
SFXbossy=LoadSound("sfx\bossy.ogg")
SFXwin=LoadSound("sfx\end.ogg")

Repeat
	Select state ;3D
		Case 0 
.prep_for_title

			ClearWorld
			state=1
		
		
			Camera = CreateCamera()
			AmbientLight 255,255,255
			
			GFXtitle=loadTheTexture("gfx/title.png")
			
			background=CreateCube()
		
			EntityTexture background,GFXtitle
			ScaleEntity background,40,30,1
			PositionEntity background,0,0,41

			Dim GFXblockTextures(6)
			For i=0 To 6
				GFXblockTextures(i)=loadTheTexture("gfx/BLOCK"+(i+1)+".BMP")
			Next ;i
			
			titlePivot=CreatePivot()
			MoveEntity titlePivot,0,9,30
		
			Restore titleText
			Dim titleMessage(59,9)
					
			For y=0 To 9
				For x=0 To 59
					c.cube=New cube
					Read c\t;titleMessage(x,y)
					c\e=CreateCube(titlePivot)
					c\x=x-29
					c\y=y-4
					c\z#=0
					ScaleEntity c\e,.5,.5,.5
					MoveEntity c\e,c\x,c\y,c\z#
					EntityTexture c\e,GFXblockTextures(c\t)
				Next ;x
			Next ;y

			GFXplay=LoadImage("gfx/play.png")
			GFXplayWidth=ImageWidth(GFXplay)

			Cls
			Flip
			Cls

		Case 1 
.title_screen
			If maincount<180 Then TurnEntity titlePivot,2,0,0
			For c.cube=Each cube
	
				If c\t>0
					TurnEntity c\e,0,5,0
				Else
					count=count+1
					c\z=Sin(count)				
				EndIf
				PositionEntity c\e,c\x,c\y,c\z#
			Next ;c
			maincount=maincount+2
			
			If KeyHit(57) Then state=2
		Case 2;prep for character selection

			ClearWorld

			Dim GFXblockTextures(6)
			For i=0 To 6
				GFXblockTextures(i)=loadTheTexture("gfx/BLOCK"+(i+1)+".BMP")
			Next ;i

			
			For c.cube=Each cube
				Delete c
			Next ;c
			
			state=3
			
		
			Camera = CreateCamera()
			AmbientLight 255,255,255
			
			GFXtitle=loadTheTexture("gfx/character.png")
			
			background=CreateCube()
		
			EntityTexture background,GFXtitle
			ScaleEntity background,40,30,1
			PositionEntity background,0,0,41

			currentChar=0
			
			playerPivot=createChar(currentChar)
				MoveEntity playerPivot,0,-2.5,5

			ok=True

			Dim characterInfo$(6,19)
			
			initCharacterInfo()
			
			Cls
			Flip
			Cls
		Case 3
.character_selection
	
					
			If KeyDown(203) Or KeyDown(205) And ok=True
				For c.cube=Each cube
					FreeEntity c\e
					Delete c
				Next ;c
				
				currentChar=currentChar+KeyHit(205)-KeyHit(203)
				currentChar=rmod(currentChar,7)
							
				playerPivot=createChar(currentChar)
				MoveEntity playerPivot,-1,-2.5,5

				ok=False
			Else
				ok=True
			EndIf
			;TurnEntity playerPivot,10,3,0
			
			If KeyHit(57)
				state=4
				For i=100 To 1 Step -5
					f#=(Float#(i))/100.0
					EntityAlpha background,f#
					UpdateWorld 
					RenderWorld 
					Flip
					If KeyDown(1) Then Exit 
				Next ;i
				EntityAlpha background,0.0
				For i=0 To 10
					f#=(Float#(i)/10.0)*2
					MoveEntity playerPivot,f#,0,0	
					UpdateWorld 
					RenderWorld 
					Flip
					If KeyDown(1) Then Exit 
				Next; i
			EndIf
		Case 4 
.prep_for_game

			playerspeed#=.4
			
			ClearWorld
			

			Dim GFXblockTextures(7)
			For i=0 To 7
				GFXblockTextures(i)=loadTheTexture("gfx/BLOCK"+(i+1)+".BMP")
			Next ;i

			IMGcube=LoadTheImage("gfx/BLOCK8.BMP")

			For c.cube=Each cube
				Delete c
			Next ;c
		
			AmbientLight 255,255,255

			playerPivot=createChar(currentChar)
			ScaleEntity playerPivot,.2,.2,.2
			EntityType playerPivot,TYPE_PLAYER

;For c.cube=Each cube
;	If c\t<7
;		EntityType c\e,TYPE_PLAYER;,True
;	EndIf
;Next ;c.cube

			
			;MoveEntity playerPivot,1,-2.5,5
			
			camera = CreateCamera();playerPivot)


			skysphere=CreateSphere(20,camera)
			ScaleEntity skysphere,150,150,150
			EntityColor skysphere,50,200,255
			EntityFX skysphere,1
			FlipMesh skysphere
			
			
			CameraViewport camera,0,0,GraphicsWidth(),GraphicsHeight()
			CameraRange camera,.01,200

			CameraFogMode camera,1
			CameraFogColor camera,50,200,255

			EntityType camera,TYPE_CAMERA

			;MoveEntity camera,0,10,-15
			
			terrainOffset=0
			terrainScale=4
			
			GFXgrassTex=loadTheTexture("gfx/grasstex.png")
			terrain=LoadTerrain("gfx/heightmap.bmp")
			ScaleEntity terrain,terrainScale,20,terrainScale
			PositionEntity terrain,terrainOffset,-40,terrainOffset
						
			EntityType terrain,TYPE_TERRAIN
													
			GFXrockTex=loadTheTexture("gfx/rocktex.png")
			rock=LoadTerrain("gfx/rock.png")
			ScaleEntity rock,terrainScale,30,terrainScale
			PositionEntity rock,terrainOffset,-45,terrainOffset
			EntityTexture rock,GFXrockTex
			ScaleTexture GFXrockTex,.25,.25
			EntityType rock,TYPE_ROCK

			

			Collisions TYPE_CAMERA,TYPE_TERRAIN,2,3

			Collisions TYPE_BADDY,TYPE_ROCK,2,2		
		;	Collisions TYPE_PLAYER,TYPE_TERRAIN,2,3

;			Collisions TYPE_CAMERA,TYPE_ROCK,2,4

			Collisions TYPE_PLAYER,TYPE_ROCK,2,2
			Collisions TYPE_PLAYER,TYPE_BADDY,2,2
			


			EntityRadius playerPivot,1
			
			OBJtree=LoadMesh("objects\tree.3DS")
			ScaleMesh OBJtree,.1,.1,.1
			HideEntity OBJtree
			EntityType OBJtree,TYPE_ROCK
			
			light=CreateLight(1,playerPivot)
			RotateEntity light,90,0,0
			MoveEntity light,0,10,0
			
			GFXfence=LoadMesh("gfx\afreckingrectangle.3DS",playerPivot)
			MoveEntity GFXfence,0,3.5,0
			HideEntity GFXfence
			EntityType GFXfence,TYPE_ROCK
			EntityAlpha GFXfence,.25
			ftex=LoadTexture("gfx/BLOCK9.png")
			EntityTexture GFXfence,ftex
			ScaleEntity GFXfence,.1,.1,.1

			GFXgate=LoadMesh("gfx\gate.3DS",playerPivot)
			MoveEntity GFXgate,0,3.5,0
			HideEntity GFXgate
			EntityType GFXgate,TYPE_ROCK
			EntityAlpha GFXgate,.25
			gtex5=LoadTexture("gfx/5gate.png")
			gtex10=LoadTexture("gfx/10gate.png")
			gtex25=LoadTexture("gfx/25gate.png")

			EntityTexture GFXgate,gtex5
			ScaleEntity GFXgate,.1,.1,.1

			
			GFXthumb=LoadMesh("gfx\thumb.3DS",playerPivot)
			MoveEntity GFXthumb,0,0,0
			ttex=LoadTexture("gfx\thumbtex.png")
			EntityTexture GFXthumb,ttex
			ScaleEntity  GFXthumb,.1,.1,.1
			HideEntity GFXthumb
			EntityType GFXthumb,TYPE_BADDY

			EntityRadius GFXthumb,.25
			
	;		dammitsonofbeech=LoadMesh("gfx\monsterghost.3DS")
	;		ALFDKJASLFKJD=CreateSphere(10,dammitsonofbeech)
	;		ScaleEntity ALFDKJASLFKJD,10,40,10
			baddyghost=LoadMesh("gfx\monsterghost.3DS")
	
	
	;		PositionEntity dammitsonofbeech,180,-35,220
			PositionEntity baddyghost,180,-35,220

			mtex=LoadTexture("gfx\monsterghost.png")
			EntityTexture baddyghost,mtex
			;TurnEntity baddyghost,0,40,0
	;		ScaleEntity  dammitsonofbeech,.05,.05,.05
			ScaleEntity  baddyghost,.05,.05,.05
			EntityType baddyghost,TYPE_BADDY
			EntityRadius baddyghost,3
			
	;		EntityAlpha dammitsonofbeech,0.1
			EntityAlpha baddyghost,1

			Dim checkbutts(2)
			Dim butts(2)
			Dim butthit(2)
			
			For i=0 To 2
				butts(i)=CreateCylinder(10,True)
				EntityColor butts(i),200,200,200
				ScaleEntity butts(i),1,2,1
				EntityType butts(i),TYPE_ROCK
				EntityAlpha butts(i),.75

				checkbutts(i)=CreateCylinder(10,True,butts(i))
				EntityColor checkbutts(i),200,0,0
				ScaleEntity checkbutts(i),.5,1.25,.5
				EntityType checkbutts(i),TYPE_ROCK
				EntityAlpha checkbutts(i),1



			Next ;i		
				PositionEntity butts(0),220,-36,189
				PositionEntity butts(1),189,-36,241
				PositionEntity butts(2),177,-36,205

				
			ok=False
			;Repeat
			;	infinitelooppreventer=infinitelooppreventer+1
			;	If infinitelooppreventer>1000 Then ok=True
				
			;	For i=0 To 2
			;		MoveEntity butts(i),0,0,1
			;		If terrain=EntityCollided(butts(i),TYPE_ROCK)
			;			checkbutts(i)=1
			;			happy$="yay"
			;		EndIf
			;	Next ;i
			;	
			;Until ok=True Or (checkbutts(0)+checkbutts(1)+checkbutts(2)=3)
				
				
	;Stop
			GFXmap=LoadTheImage("gfx\map.png")
			
			GFXdead=LoadTheImage("gfx\dead.png")
			MaskImage GFXdead,255,0,0

startx=25
starty=-30
startz=25

bossstartx=181
bossstarty=-35
bossstartz=203

			playerMic=CreateListener(playerPivot,1,1,20)
		;	cameraMic=CreateListener(cameraPivot,1,1,20)

			;boss starting coords

		PositionEntity playerPivot,181.391708,-34.62761,203.106339		
		setThePuckingFosition(playerPivot,bossstartx,bossstarty,bossstartz)
			PositionEntity camera,180,-35,220

	;real starting coords

;If 0=1
	PositionEntity camera,20,-40,20
	PositionEntity playerPivot,25,-30,25
	setThePuckingFosition(playerPivot,startx,starty,startz)
	
;EndIf
		
EntityTexture terrain, GFXgrassTex, 0, 0
ScaleTexture GFXgrassTex,.25,.25



cubez=0
linez=0

dead=False

CameraFogMode camera,1
CameraFogColor camera,50,200,255
CameraFogRange camera,30,50

			Cls
			Flip
			Cls
			
			loadLevel("level\grassland.map")
			
			state=5
			
jumpcounter=-1
			
		Case 5 
.game
		If dead=False
		

	
		If getXZDistance(playerPivot,baddyghost)<14 And BOSSMODE=False
			BOSSMODE=True
			LoopSound SFXghosty
			bossysound=EmitSound(SFXghosty,baddyghost)

			StopChannel music
			LoopSound SFXbossy
			music=PlaySound(SFXbossy)

			
		EndIf


				HideEntity GFXfence
				HideEntity GFXthumb
				HideEntity GFXgate
				
				If controlkey() And KeyHit(18) And 1=0
					If editmode=False				
						px=Int(EntityX#(playerPivot))
						py=Int(EntityY#(playerPivot))+.75
						pz=Int(EntityZ#(playerPivot))
					
						editmode=True
					
						c.cube=New cube
						c\e=CreateCube()
						
						c\x#=px
						c\y#=py
						c\z#=pz
						
						c\t=8
						ScaleEntity c\e,.2,.2,.2
						PositionEntity c\e,c\x#,c\y#,c\z#
						EntityAlpha c\e,.5
						
						
					Else
						
						For c.cube=Each cube
							If c\t=8
								FreeEntity c\e
								Delete c
							EndIf
						Next ;c.cube
						
						editmode=False
						
						saveLevel("level\grassland.map")
					
					EndIf
				EndIf
			;controls				
				
			If editmode=False

;				TurnEntity playerPivot,0,(KeyDown(203)-KeyDown(205))*15,0
;				MoveEntity playerPivot,0,0,(KeyDown(200)-KeyDown(208))*(.5+(shiftkey()))

				If KeyDown(200)
					PointEntity playerPivot,camera
					RotateEntity playerPivot,0,EntityYaw#(playerPivot)+180,0

					MoveEntity playerPivot,0,0,playerspeed# ;+(2*shiftkey())

				EndIf
	
				If KeyDown(203)
					PointEntity playerPivot,camera
					RotateEntity playerPivot,0,EntityYaw#(playerPivot)-90,0

					MoveEntity playerPivot,0,0,playerspeed#; +(2*shiftkey())

				EndIf
	
				If KeyDown(205)
					PointEntity playerPivot,camera
					RotateEntity playerPivot,0,EntityYaw#(playerPivot)+90,0

					MoveEntity playerPivot,0,0,playerspeed#; +(2*shiftkey())

				EndIf
					If KeyDown(208)
					PointEntity playerPivot,camera
					
					RotateEntity playerPivot,0,EntityYaw#(playerPivot),0

					MoveEntity playerPivot,0,0,playerspeed#


				EndIf
	

;	If KeyDown(2) Then TurnEntity playerPivot,0,10,0
	
				px=Int(EntityX#(playerPivot));+1.5)/3)
				pz=Int(EntityZ#(playerPivot));+1.5)/3)
		cubeCollide=EntityCollided(playerPivot,TYPE_ROCK)


				
	For c.cube=Each cube
		If c\t=7 
			If cubeCollide<>0
			
				If c\gotted=False And cubeCollide=c\e
				

					c\gotted=True
					cubez=cubez+1
					PlaySound SFXbrick
					If cubez=10
						linez=linez+1
						PlaySound SFXscore
						cubez=0
					EndIf
	
				EndIf
			EndIf
			If c\gotted=True
				MoveEntity c\e,0,1,0
				If EntityY#(c\e)>10
					FreeEntity c\e
					c\t=100
				EndIf
			EndIf
		EndIf
		
		
	Next
				
	gateCollide=EntityCollided(playerPivot,TYPE_ROCK)

	For g.gate=Each gate
		If BOSSMODE=True 
			
					PositionEntity g\e,g\x#,g\y#-0.5,g\z#

			
					g\x#=g\ox#
					g\y#=g\oy#
					g\z#=g\oz#

		Else
		
			If g\gotted=False And g\e=gateCollide And g\blox<=linez
				g\gotted=True
				linez=linez-g\blox
				PlaySound SFXcrumble
			EndIf
			If g\gotted=True Then MoveEntity g\e,Rnd(-.1,.1),-.1,Rnd(-.1,.1)
		EndIf
	Next ;g.gate
	
							

				moveThumbs()		
.BOSSMODE
If BOSSMODE=True
		buttcounter=0
		buttmover=buttmover+1
		
		blinkcounter=blinkcounter+1
		
		For i=0 To 2
	;		PositionEntity butts(i),EntityX#(butts(i)),Sin#(buttmover),EntityY#(butts(i))	
			MoveEntity butts(i),0,Sin#(buttmover)/100,0
	
			buttCollide=EntityCollided(playerPivot,TYPE_ROCK)
			If buttCollide=checkbutts(i) Then butthit(i)=1
	
			If butthit(i)
				EntityColor butts(i),0,255,0
				buttcounter=buttcounter+1
			Else
				If (blinkcounter/10) Mod 2=0
					EntityColor butts(i),255,0,0
				Else
					EntityColor butts(i),200,200,200
				EndIf
			EndIf
		Next ;i
	
		If buttcounter=3 Then state=6

	
		bossCollide=EntityCollided(playerPivot,TYPE_BADDY)
		If bossCollide=baddyghost 
			dead=True
	
			PlaySound SFXdead
			StopChannel music

		EndIf
		
		TurnEntity baddyghost,0,-210,0
	
	
		If bosscount=0
			PointEntity baddyghost,playerPivot
			RotateEntity baddyghost,0,EntityYaw#(baddyghost),0
		EndIf
	
		
		bosscount=bosscount+1
		
		If bosscount>40
			bossacc#=bossacc#+.02+(Float#(buttcounter)/50)
			bossspeed#=bossspeed#+bossacc#
			If bossspeed#>1.5 Then bossspeed#=1.5
		ElseIf bosscount=40
			
			PointEntity baddyghost,playerPivot
			RotateEntity baddyghost,0,EntityYaw#(baddyghost),0

		
		Else
			oldyaw#=EntityYaw#(baddyghost)
			PointEntity baddyghost,playerPivot
			newyaw#=EntityYaw#(baddyghost)
			RotateEntity baddyghost,0,oldyaw#,0


			TurnEntity baddyghost,0,Sin#(bosscount*10)*5,0

		EndIf
			
		If bosscount>100 
			bosscount=0
			bossspeed#=0
			bossacc#=0
		EndIf
		
		MoveEntity baddyghost,0,-.5,bossspeed#
		TurnEntity baddyghost,0,210,0
	
		If EntityY#(baddyghost)<=TerrainY#(terrain,EntityX#(baddyghost),EntityY#(baddyghost),EntityZ#(baddyghost))
			PositionEntity baddyghost,EntityX#(baddyghost),TerrainY#(terrain,EntityX#(baddyghost),EntityY#(baddyghost),EntityZ#(baddyghost)),EntityZ#(baddyghost)
		EndIf			
	

EndIf		
		
.editmode
			Else
			
			;209;201
				If KeyDown(209) MoveEntity playerPivot,0,-1,0
				If KeyDown(209) MoveEntity playerPivot,0,-1,0
				
				px=Int(EntityX#(playerPivot))
				py=(EntityY#(playerPivot))+.75
				pz=Int(EntityZ#(playerPivot))
				
				MoveEntity playerPivot,(KeyHit(203)-KeyHit(205)),0,(KeyHit(208)-KeyHit(200))
				PositionEntity camera,EntityX#(playerPivot)-.25,EntityY#(playerPivot)+9.0,EntityZ#(playerPivot)-2		

				If KeyHit(57) Then turn=(turn+1) Mod 9
				
				RotateEntity playerPivot,0,turn*45,0

						
				For c.cube=Each cube
					If c\t=8
						c\x#=px
						c\y#=py
						c\z#=pz
						
						PositionEntity c\e,c\x#,c\y#,c\z#
					EndIf
				Next ;c.cube
				
				If KeyHit(15)
					editPlace=editPlace+1
					If editPlace>4 Then editPlace=0
				EndIf


				
				If editPlace=0
					If MouseHit(2) Then deleteCube(playerPivot,px,py,pz)
					If MouseHit(1)
						deleteCube(playerPivot,px,py,pz)
						
						c.cube=New cube
						c\e=CreateCube()
						
						EntityType c\e,TYPE_ROCK
						
						c\x#=px
						c\y#=py
						c\z#=pz
						
						c\ox#=px
						c\oy#=py
						c\oz#=pz

						c\t=7
						ScaleEntity c\e,.2,.2,.2
						PositionEntity c\e,c\x#,c\y#,c\z#
						EntityTexture c\e,GFXblockTextures(7)
					EndIf
				ElseIf editPlace=1
					If MouseHit(1)
						t.tree=New tree
						t\e=CopyEntity(OBJtree)
						t\x#=px
						t\y#=EntityY#(playerPivot)
						t\z#=pz
						ScaleEntity t\e,.1,.1,.1
						PositionEntity t\e,t\x#,t\y#,t\z#
						treecount=treecount+1
					EndIf
					If MouseHit(2)
						If treecount>0
							t.tree=Last tree
							FreeEntity t\e
							Delete t
							treecount=treecount-1
						EndIf
					EndIf
				ElseIf editPlace=2
				
					ShowEntity GFXfence
					If MouseHit(1)
							
							fn.fence=New fence
							fn\e=CopyEntity(GFXfence)
							fn\x#=px
							fn\y#=py+1.5;EntityY#(playerPivot)
							fn\z#=pz
							fn\a=(Int(EntityYaw(playerPivot))/45)*45
							EntityAlpha fn\e,1
							PositionEntity fn\e,fn\x#,fn\y#,fn\z#
							RotateEntity fn\e,0,fn\a,0			
							fn.fence=New fence
							fn\e=CopyEntity(GFXfence)
							fn\x#=px
							fn\y#=py-0.5;EntityY#(playerPivot)
							fn\z#=pz
							fn\a=(Int(EntityYaw(playerPivot))/45)*45

							EntityAlpha fn\e,1
							PositionEntity fn\e,fn\x#,fn\y#,fn\z#
							RotateEntity fn\e,0,fn\a,0
							
							wallcount=wallcount+1
					EndIf
					If MouseHit(2)
						If wallcount>0
							fn.fence=Last fence
							FreeEntity fn\e
							Delete fn	
	
							fn.fence=Last fence
							FreeEntity fn\e
							Delete fn
						
							wallcount=wallcount-1
						EndIf

					EndIf
				ElseIf editPlace=3
					
					EntityType GFXthumb,TYPE_NOTHING

					ShowEntity GFXthumb
					If MouseHit(1)
							
							b.thumb=New thumb
							b\e=CopyEntity(GFXthumb)
							b\x#=px
							b\y#=py;EntityY#(playerPivot)
							b\z#=pz

							b\ox#=px
							b\oy#=py;EntityY#(playerPivot)
							b\oz#=pz

DebugLog "Thumb placed at "+b\ox#+","+b\oz#

DebugLog "Player at "+EntityX#(playerPivot)+","+EntityZ#(playerPivot)

							b\a=(Int(EntityYaw(playerPivot))/45)*45
							
							PositionEntity b\e,b\x#,b\y#,b\z#
							RotateEntity b\e,0,b\a,0
							ScaleEntity b\e,.03,.03,.03
							
							thumbcount=thumbcount+1
					EndIf
					If MouseHit(2)
						If thumbcount>0
							b.thumb=Last thumb
							FreeEntity b\e
							Delete b	
	
							thumbcount=thumbcount-1
						EndIf

					EndIf					
					EntityType GFXthumb,TYPE_BADDY
				Else editPlace=4
					If KeyHit(2) Then gatetype=5
					If KeyHit(3) Then gatetype=10
					If KeyHit(4) Then gatetype=25
					If gatetype=0 Then gatetype=5
					ShowEntity GFXgate
					If MouseHit(1)
							
							g.gate=New gate
							g\e=CopyEntity(GFXgate)
							g\x#=px
							g\y#=py-1;EntityY#(playerPivot)
							g\z#=pz
							g\ox#=px
							g\oy#=py-1
							g\oz#=pz


							g\a=(Int(EntityYaw(playerPivot))/45)*45
							EntityAlpha g\e,1
							PositionEntity g\e,g\x#,g\y#,g\z#
							RotateEntity g\e,0,g\a,0
							
							g\blox=gatetype
							
							If g\blox=5
								EntityTexture g\e,gtex5
							ElseIf g\blox=10
								EntityTexture g\e,gtex10
							ElseIf g\blox=25
								EntityTexture g\e,gtex25
							EndIf
							
							gatecount=gatecount+1
					EndIf
					If MouseHit(2)
						If gatecount>0
							g.gate=Last gate
							FreeEntity g\e
							Delete g	
							
							gatecount=gatecount-1
						EndIf

					EndIf

				EndIf

			EndIf

			;fall, jump
			If EntityY#(playerPivot)<=TerrainY#(terrain,EntityX#(playerPivot),EntityY#(playerpivot),EntityZ#(playerPivot))	
				If fall#>0 Then fall#=0
				fallspeed#=0
				PositionEntity playerPivot,EntityX#(playerPivot),TerrainY#(terrain,EntityX#(playerPivot),EntityY#(playerpivot),EntityZ#(playerPivot)),EntityZ#(playerPivot)
			
				If KeyDown(57) 
					fall#=-.3;  -(shiftkey())
					If jumpcounter=-1
						jumpcounter=0
						jumpnum=1
						PlaySound SFXjump1
					ElseIf jumpnum=1
						PlaySound SFXjump2
						jumpnum=2
					ElseIf jumpnum=2
						jumpcounter=-1
						jumpnum=0
						PlaySound SFXjump3
					EndIf

				EndIf

				If jumpcounter>-1
					jumpcounter=jumpcounter+1
					If jumpcounter>10 
						jumpcounter=-1
						jumpnum=0
					EndIf
				EndIf

			Else
				fallspeed#=fallspeed#+.01
				fall#=fall#+fallspeed#
			EndIf		


			
			MoveEntity playerPivot,0,-fall#,0
			
			If count>0
;				PositionEntity playerPivot,20,-30,20,True
				count=0
			EndIf
		Else
	


.DEAD
		If MilliSecs()-deadtimer>1000
			count=count+1
			If count=50 Then crappydeathhurt=PlaySound(SFXDONG)
			
			
		;	CameraFogMode camera,1
			CameraFogColor camera,255,0,0
			If count<=50
				CameraFogRange camera,0,50-count
			EndIf
		
			AmbientLight 255,0,0
			LightColor light,255,0,0
			If GetKey()<>0 And count>100

				For th.thumb=Each thumb
					th\x=th\ox
					th\y=th\oy
					th\z=th\oz
				Next ;thumb

			;	count=0
				dead=False
				
				StopChannel crappydeathhurt
				music=PlayMusic("tetrisnt.xm")
				ChannelVolume music,.5

				CameraFogMode camera,1
				CameraFogColor camera,50,200,255
				CameraFogRange camera,30,50
				AmbientLight 255,255,255	
				LightColor light,255,255,255

				textx=EntityX(playerPivot)
				testz=EntityZ(playerPivot)
					
				PositionEntity camera,20,-40,20,True		
				PositionEntity playerPivot,20,00,20,True
				

				textx=EntityX(playerPivot)
				testz=EntityZ(playerPivot)
					
				deadtimer=MilliSecs()
				
				If BOSSMODE=True
					setThePuckingFosition(playerPivot,bossstartx,bossstarty,bossstartz)
					PositionEntity baddyghost,180,-35,220
					StopChannel music
					LoopSound SFXbossy
					music=PlaySound(SFXbossy)
				Else
					setThePuckingFosition(playerPivot,startx,starty,startz)
				EndIf
				
				For i=0 To 2
					butthit(i)=0
				Next ;i

				;BOSSMODE=False
			EndIf
			FlushKeys
		Else
			dead=False
		EndIf
	EndIf
	End Select

;textx=EntityX(playerPivot)
;testz=EntityZ(playerPivot)
	
;DebugLog "Before Update:"+EntityX#(playerPivot)+","+EntityY#(playerPivot)+","+EntityZ#(playerPivot)

	UpdateWorld

;DebugLog "After Update:"+EntityX#(playerPivot)+","+EntityY#(playerPivot)+","+EntityZ#(playerPivot)

	RenderWorld
	
;DebugLog "After Render:"+EntityX#(playerPivot)+","+EntityY#(playerPivot)+","+EntityZ#(playerPivot)

;textx=EntityX(playerPivot)
;testz=EntityZ(playerPivot)

.states_2D_and_post_render_actions
	Select state ;2D			
		Case 1 ;title screen
			
			If MilliSecs()/500 Mod 2=0 
				DrawBlock GFXplay,400-(GFXplayWidth/2),280
			EndIf
			
		Case 3 ;character selection
			For i=0 To 19
				Text 550,150+(i*15),characterInfo$(currentChar,i)
			Next ;i	
		Case 5 ;game
			
			;camera
			
			PointEntity camera,playerPivot
			If BOSSMODE=True
			
				PositionEntity camera,200,-30,220

			Else
			
				distanceToPlayer=getdistance(camera,playerPivot)
				If distanceToPlayer>3.5
					MoveEntity camera,0,.12,Float#(distanceToPlayer)/15
				ElseIf distanceToPlayer<2.5
					MoveEntity camera,0,-.1,0;,Float#(distanceToPlayer)/50
					
					RotateEntity camera,0,EntityYaw#(camera),0
					
	;				movespeed
					
					MoveEntity camera,0,0,-playerspeed#
		
					PointEntity camera,playerPivot
				EndIf

			EndIf


			Color 255,255,255
			

	If dead=False
		If editmode 
			Color 0,0,0
			Text 1,581,"EDIT MODE ON"
		
			Color 255,255,0
			Text 0,580,"EDIT MODE ON"
		;	PositionEntity camera,EntityX#(playerPivot)+.25,EntityY#(playerPivot)+9.0,EntityZ#(playerPivot)-.25		
		Else
			;PositionEntity camera,EntityX#(camera),EntityY#(playerPivot)+3.0,EntityZ#(camera)			
		EndIf
	
		lineStr$="Lines: "+linez
		fonttext(centerx(lineStr$),0,lineStr$,idiotfont)
	
		For i=0 To 9
			If i<cubez
				DrawBlock IMGcube,(240)+((i*32)),36			
			Else
				Color 0,0,0 
				Rect (240)+((i*32)),36,32,32,True
				
				Color 255,255,255
				Rect (240)+((i*32)),36,32,32,False
			EndIf
		Next;i
		
		DrawBlock GFXmap,0,0
		
		Color 0,0,255
		Oval (EntityX#(playerPivot))/4,64-((EntityZ#(playerPivot))/4),3,3,True

	ElseIf count>75
		ClsColor 255,0,0
		Cls
		DrawImage GFXdead,250,200		


	EndIf
;state=6
.WIN_THE_GAME
Case 6 ;winner!
	StopChannel music
	
	LoopSound SFXwin
	music=PlaySound(SFXwin)
	
	idiot=LoadMesh("gfx\idiot.3DS")
	ScaleEntity idiot,.025,.025,.025
	
	idiotstex=LoadTheTexture("gfx/idiot1.png")
	idiothtex=LoadTheTexture("gfx/idiot2.png")
	idiotptex=LoadTheTexture("gfx/idiot3.png")

	
	EntityTexture idiot,idiotstex
	Cls
	Flip
	Cls
	Flip
	
	setThePuckingFosition(baddyghost,200,-34,220)

	setThePuckingFosition(idiot,200,-33,220)

;	HideEntity idiot

	setThePuckingFosition(playerPivot,197,-34,215)	
	setThePuckingFosition(camera,209,-25,210)

	PointEntity camera,idiot
	PointEntity idiot,playerPivot
	RotateEntity idiot,0,EntityYaw#(idiot)+180,0

	cake=CreateCylinder(10)
	caketex=loadTheTexture("gfx\cake.png")
	EntityTexture cake,caketex
	ScaleEntity cake,.4,.25,.4
	
	bosszscale#=.05
	
	state=7

	winstate=0
Case 7	;YAAAAY!!  I GOT MAIL!!!
	
	If winstate=0
		bossbye#=bossbye#+.05
		MoveEntity baddyghost,0,bossbye#,0
	
		bosszscale#=bosszscale#-.002
		If bosszscale#<.001 Then bosszscale#=.001
		ScaleEntity baddyghost,.05,.05+(bosszscale#/2),bosszscale#
	
		If bossbye#>3
			EntityTexture idiot,idiothtex
			winstate=1
			bossbye#=0
		EndIf


	
		MoveEntity camera,-bossbye#/10,0,bossbye#/15
		PointEntity camera,idiot


	ElseIf winstate=1
		count=count+1
		If count=10 Then EntityTexture idiot,idiotptex
		If count=12 Then setThePuckingFosition(cake,199,-30,219)
		If count>12 
			PointEntity cake,playerPivot
			
			MoveEntity cake,0,0,.04
			
			RotateEntity cake,0,EntityYaw#(cake),0

		EndIf
		If count=15 Then EntityTexture idiot,idiothtex
		If count>50 Then winstate=2
	ElseIf winstate=2
		FreeEntity terrain
		FreeEntity rock
		
		FreeEntity light
		AmbientLight 30,30,30
		light=CreateLight(3)
		PointEntity light,cake
		winstate=3
		
		
For c.cube=Each cube ;little cubes.... little... cubes
	If c\t=7 Then FreeEntity c\e
Next ;c.cube

For t.tree=Each tree
	FreeEntity t\e
Next ;t.tree
For fn.fence=Each fence
	FreeEntity fn\e
Next 
For g.gate=Each gate
	FreeEntity g\e
Next
For th.thumb=Each thumb
	FreeEntity th\e
Next		
FreeEntity skysphere


	Else
		
	
		MoveEntity camera,-.1,0,0
		PointEntity camera,cake
		
	EndIf	
	UpdateWorld
	RenderWorld


	scrolltext()
	
End Select

;DebugLog "END:"+EntityX#(playerPivot)+","+EntityY#(playerPivot)+","+EntityZ#(playerPivot)

	;fonttext(0,500,getXZdistance(playerPivot,baddyghost),idiotfont)


	Flip

	;F9 screenshot
	If KeyHit(67) Or (JoyDown(8)) Then SaveBuffer(FrontBuffer(), "TAW3D"+Rand(10000,99999)+".bmp")


Until KeyDown(1)

ClearWorld

EndGraphics 
End
.end________

Function setThePuckingFosition(ent,x,y,z)
	Repeat
	
		DebugLog "Attempting to put you at :"+x+","+y+","+z

	
		PositionEntity ent,x,y,z
		UpdateWorld
		If EntityX(ent)=x And EntityY(ent)=y And EntityZ(ent)=z Then ok=True
		SADFSDLJWELFHWEHFKEDTHSDFHIU=SADFSDLJWELFHWEHFKEDTHSDFHIU+1
		
		If SADFSDLJWELFHWEHFKEDTHSDFHIU>1000 Then ok=True;RuntimeError("THERE IS A HATE THAT BURNS WITHIN.")
		y=y+1
	Until ok=True

	
	DebugLog "Supposedly put you at :"+x+","+y+","+z
	DebugLog "Actuall put you at :"+EntityX#(playerPivot)+","+EntityY#(playerPivot)+","+EntityZ#(playerPivot)

End Function

Function moveThumbs()

	If MilliSecs()-deadtimer>1000
		thumbCollide=EntityCollided(playerPivot, TYPE_BADDY)
	Else
		dead=False
	EndIf
	
	For t.thumb=Each thumb
	
		distToPlayer=getDistance(playerPivot,t\e)
		
			If thumbCollide=t\e
				;owie
				dead=True
				PlaySound SFXdead
				StopChannel music
			EndIf
If 1=1
			If distToPlayer<10	
				MoveEntity t\e,0,-t\fall#,.25
				
				If EntityY#(t\e)<=TerrainY#(terrain,EntityX#(t\e),EntityY#(t\e),EntityZ#(t\e))
					If t\fall#>0 Then t\fall#=0
					t\fallspeed#=0
					PositionEntity t\e,EntityX#(t\e),TerrainY#(terrain,EntityX#(t\e),EntityY#(t\e),EntityZ#(t\e)),EntityZ#(t\e)
				
					t\fall#=-.2
					thumbsound=EmitSound (SFXthumb,t\e)

					
					PointEntity t\e,playerPivot
					RotateEntity t\e,0,EntityYaw#(t\e),0

				Else
					t\fallspeed#=t\fallspeed#+.025
					t\fall#=t\fall#+t\fallspeed#
				EndIf
			ElseIf distToPlayer<50	
		;5		ShowEntity t\e
				MoveEntity t\e,0,-t\fall#,.1
	
				If EntityY#(t\e)<=TerrainY#(terrain,EntityX#(t\e),EntityY#(t\e),EntityZ#(t\e))
					If t\fall#>0 Then t\fall#=0
					t\fallspeed#=0
					PositionEntity t\e,EntityX#(t\e),TerrainY#(terrain,EntityX#(t\e),EntityY#(t\e),EntityZ#(t\e)),EntityZ#(t\e)
				
						t\fall#=-.4
						thumbsound=EmitSound(SFXthumb,t\e)
				Else
					t\fallspeed#=t\fallspeed#+.003
					t\fall#=t\fall#+t\fallspeed#
				EndIf

				If Rand(0,75)=55 Then TurnEntity t\e,0,Rand(-80,60),0
			Else
		;		PositionEntity t\e,EntityX#(t\e),EntityY#(t\e),EntityZ#(t\e)
	

			EndIf
EndIf

;TurnEntity t\e,0,20,0
	Next ;t.thumb
End Function

Function deleteCube(piv,px,py,pz)

	For c.cube=Each cube
		If c\t=7
			If Int(c\x#)=px And Int(c\y#)=py And Int(c\z#)=pz
				FreeEntity c\e
				Delete c
			EndIf
		EndIf
	Next ;c.cube
End Function

Function createChar(n)
	piv=CreatePivot()
	For y=0 To 3
		For x=0 To 3
			If pieces(n,x,y)>0
				c.cube=New cube
				c\e=CreateCube(piv)
				c\x#=x-1.5
				c\y#=4-y
				c\z#=0
				c\t=n
				ScaleEntity c\e,.5,.5,.5
				MoveEntity c\e,c\x#,c\y#,c\z#
				EntityTexture c\e,GFXblockTextures(c\t)
				
			EndIf
		Next ;x
	Next ;y

	Return piv	
End Function

Function scrolltext()
	textlinecounter=textlinecounter+1+(3*KeyDown(57))
	
	For e.endmessage=Each endmessage
		fonttext(centerx(e\message$)+e\x#,e\y,e\message$,idiotfont)
		e\y=e\y-(1+(3*KeyDown(57)))
		If e\y<150 
			e\xx#=e\xx#+.1
			e\x#=e\x#+e\xx#
		EndIf
		If e\y<-50 Then Delete e
	Next ;e.endmessage
	
	If textlinenum<=ENDTEXTSIZE
		If textlinecounter>35
	
			e.endmessage=New endmessage
			e\message$=endtext$(textlinenum)
			e\y=750
			
			textlinenum=textlinenum+1
				
			textlinecounter=0
		EndIf
	EndIf
End Function

Function getdistance(entity1,entity2)
	distance=Sqr((EntityX#(entity1)-EntityX#(entity2))^2+(EntityY#(entity1)-EntityY#(entity2))^2+(EntityZ#(entity1)-EntityZ#(entity2))^2)

	Return distance
End Function

Function getXZdistance(entity1,entity2)
	distance=Sqr((EntityX#(entity1)-EntityX#(entity2))^2+(EntityZ#(entity1)-EntityZ#(entity2))^2)

	Return distance
End Function

Function rmod(val,modval)
	Return (val+modval) Mod modval
End Function

Function loadTheImage(file$)
	img=LoadImage(file$)
	If img<>0 Then Return img Else RuntimeError("Error: Image "+file$+" not found")
End Function

Function loadTheTexture(file$)
	img=LoadTexture(file$)
	If img<>0 Then Return img Else RuntimeError("Error: Texture "+file$+" not found")
End Function

Function loadLevel(file$)
;If 1=0 
	f=ReadFile(file$)
	While Not Eof(f) 
;		deleteCube(playerPivot,px,py,pz)
		tp=ReadInt(f)
		Select tp
			Case 0
				c.cube=New cube
				c\e=CreateCube()
						
				c\ox#=ReadInt(f)
				c\oy#=ReadInt(f)
				c\oz#=ReadInt(f)

				c\x#=c\ox#
				c\y#=c\oy#
				c\z#=c\oz#
											
				c\t=7
				ScaleEntity c\e,.5,.5,.5
				PositionEntity c\e,c\x#,c\y#,c\z#
				EntityTexture c\e,GFXblockTextures(7)
				
				EntityType c\e,TYPE_ROCK
						
				cubecounter=cubecounter+1
				
				If cubecounter Mod 30=19
					b.thumb=New thumb
			;		b\obj=CreatePivot();CopyEntity(GFXthumb)
					b\e=CopyEntity(GFXthumb);,b\obj)
					
					b\x#=c\x#
					b\y#=c\y#
					b\z#=c\z#
					b\ox#=b\x#
					b\oy#=b\y#
					b\oz#=b\z#
					b\a#=0
					
					PositionEntity b\e,b\ox#,b\oy#,b\oz#,True

					EntityType b\e,TYPE_BADDY
					
				;	MoveEntity b\obj,0,2,.1
					
					ScaleEntity b\e,.05,.05,.05
				EndIf
						
			Case 1 ;tree
				t.tree=New tree
				t\e=CopyEntity(OBJtree)
				t\x#=ReadInt(f)
				t\y#=ReadInt(f)
				t\z#=ReadInt(f)
				ScaleEntity t\e,.1,.1,.1
				PositionEntity t\e,t\x#,t\y#-.25,t\z#
				treecount=treecount+1

			Case 2 ;fence
				px=ReadInt(f)
				py=ReadInt(f)
				pz=ReadInt(f)
				fn.fence=New fence
				fn\e=CopyEntity(GFXfence)
				fn\x#=px
				fn\y#=py
				fn\z#=pz
				fn\a=ReadInt(f)
				EntityAlpha fn\e,1
				PositionEntity fn\e,fn\x#,fn\y#,fn\z#
				RotateEntity fn\e,0,fn\a,0				
				wallcount=wallcount+1
			Case 3 ;thumb
		;		b.thumb=New thumb
		;		b\e=CopyEntity(GFXthumb)
		;		b\ox#=ReadInt(f)
		;		b\oy#=ReadInt(f)
		;		b\oz#=ReadInt(f)
;DebugLog "Thumb loaded at "+b\ox#+","+b\oz#
		;		b\x#=b\ox#
		;		b\y#=b\oy#
		;		b\z#=b\oz#
		;		
		;		b\a#=ReadInt(f)

				stupidthingdoesntwork=ReadInt(f)
				stupidthingdoesntwork=ReadInt(f)
				stupidthingdoesntwork=ReadInt(f)
				stupidthingdoesntwork=ReadInt(f)



		;		PositionEntity b\e,b\ox#,-40,b\oz#,True
		;		RotateEntity b\e,0,b\a,0
		;		ScaleEntity b\e,.05,.05,.05
		;					
		;		thumbcount=thumbcount+1

			Case 4 ;gate
				px=ReadInt(f)
				py=ReadInt(f)
				pz=ReadInt(f)
				
				ok=True
				For g.gate=Each gate
					If g\ox#=px And g\oy#=py And g\oz#=pz
						ok=False

					EndIf
				Next ;g.gate
				
				If ok=True
					g.gate=New gate
					g\e=CopyEntity(GFXgate)
					g\ox#=px
					g\oy#=py
					g\oz#=pz

					g\x#=g\ox#
					g\y#=g\oy#
					g\z#=g\oz#

					g\a=ReadInt(f)
					g\blox=ReadInt(f)
				
					If g\blox<>5 And g\blox<>10 And g\blox<>25 Then g\blox=5
				
					EntityAlpha g\e,1
					PositionEntity g\e,g\x#,g\y#-0.5,g\z#
					RotateEntity g\e,0,g\a,0
				

					If g\blox=5
					EntityTexture g\e,gtex5
						ElseIf g\blox=10
						EntityTexture g\e,gtex10
					ElseIf g\blox=25
						EntityTexture g\e,gtex25
					EndIf
								
					gatecount=gatecount+1
				Else
					stupid=ReadInt(f)
					stupid=ReadInt(f)
				EndIf
		End Select
	Wend 
	If wallcount>0 Then wallcount=wallcount/2
	
	CloseFile f
	
;EndIf
End Function

Function saveLevel(file$)
	f=WriteFile(file$)
	For c.cube=Each cube
		If c\t=7 Or c\t=100
			WriteInt f,0
			WriteInt f,c\ox#
			WriteInt f,c\oy#
			WriteInt f,c\oz#
			
		EndIf
	Next ;c.cube
	For t.tree=Each tree
		WriteInt f,1
		WriteInt f,t\x#
		WriteInt f,t\y#
		WriteInt f,t\z#
	Next ;t.tree
	For fn.fence=Each fence
		WriteInt f,2
		WriteInt f,fn\x#
		WriteInt f,fn\y#
		WriteInt f,fn\z#
		WriteInt f,fn\a
	Next ;f.fence
	For th.thumb=Each thumb
		WriteInt f,3
		WriteInt f,th\ox#
		WriteInt f,th\oy#
		WriteInt f,th\oz#
		WriteInt f,th\a


	Next ;t.tree

	For g.gate=Each gate
		WriteInt f,4
		WriteInt f,g\ox#
		WriteInt f,g\oy#
		WriteInt f,g\oz#
		WriteInt f,g\a
		WriteInt f,g\blox
	Next ;g.gate

	CloseFile f
	
End Function

Function setendtext()
	endtext$(0)="Congraduration!  You win cake!"
	endtext$(1)="Tetropolis is now safe now!"
	endtext$(2)="All the pieceanoids can life in piece"
	endtext$(3)=""
	endtext$(4)="Credit:"
	endtext$(5)="Program - Riku Felisu"
	endtext$(6)="Music - Hurtful Day"
	endtext$(7)="Character - Shamey Onyu"
	endtext$(8)="Plot - Oops"
	endtext$(9)="Level - A blind deaf mute quad chimp"
	endtext$(10)="Concept - Hate that burns within"
	endtext$(11)="Design - Harvey Rabbit"
	endtext$(12)="Helper - Toby Kitty"
	endtext$(13)="Testing - Bali Kitty"
	endtext$(14)="Scanner Warmer - Toby Kitty"
	endtext$(15)="Bad Kitty - Bali Kitty"
	endtext$(16)="Get Down - Toby Kitty"
	endtext$(17)="Don't Eat That - Bali Kitty"
	endtext$(18)="@#!; - Mental Problems"
	endtext$(19)="Cake - The Hurlington Cake Factory"	
	endtext$(20)="3D Models - Squirminal Realty"
	
	endtext$(22)="Red 3D Cube Models: Libby, Bart"
	endtext$(23)="Osmosis, Count Hookula, George, John"
	endtext$(24)="Dave, B.A.L.D., Shane, Tigger, Moocher"
	endtext$(25)="Krylar, Fash, Mark Tiffany, Nospec"
	endtext$(26)="Pizzafreak, Genexi34, Matt Sephton"
	endtext$(27)="Angus, Willk, Simon S, Ravey"
	endtext$(28)="Oliver Kearns, The Change, Starfox"
	endtext$(29)="Morduun, Wedoe, Chiefy Brown"
	endtext$(30)="2_bits, JazzieB, Nullmind"
	endtext$(31)="Gnasher, GraFix, Blodrone, Shadee"
	endtext$(32)="Rage Matrix, Foppy, Shezzor"
	endtext$(33)="Snarty, Pokey, Cyberseth, Wiebo"
	endtext$(34)="sopisoft, andyboy_uk, misterx"
	endtext$(35)="Antony, George Bray, EdzUp"

	endtext$(36)="All the new N00BZ & old skool"
	endtext$(37)="peeps I forgot cuz I'm an idiot"
	

	endtext$(39)="Special Thanks - Mark Sibly"
	endtext$(40)="(You never meant for Blitz to "
	endtext$(41)="cause pain!)
	
	
	endtext$(42)="I deeply apologize for this game"
	endtext$(43)="Please don't hurt. 
	
	endtext$(46)="Ow! Help me!"
		
	endtext$(49)="That's it."	
	endtext$(50)="Hit [Esc] to quit!!!"
End Function

Function initCharacterInfo()
;	characterInfo$(,)=""

	characterInfo$(0,0)="Linus"
	characterInfo$(0,1)=""
	characterInfo$(0,2)="Linus is the tallest of"
	characterInfo$(0,3)="all the piecanoids.  He"
	characterInfo$(0,4)="is widely respected all"
	characterInfo$(0,5)="across the land for his"
	characterInfo$(0,6)="unique ability to"
	characterInfo$(0,7)="form a Tetris.  However"
	characterInfo$(0,8)="he is a bit thin and"
	characterInfo$(0,9)="not very tough."
	characterInfo$(0,0)="Linus"
	
	characterInfo$(1,0)="Elly"
	characterInfo$(1,1)=""
	characterInfo$(1,2)="Elly and her twin"
	characterInfo$(1,3)="brother Jay are a rowdy"
	characterInfo$(1,4)="couple of piecanoids."
	characterInfo$(1,5)="Elly is curious and"
	characterInfo$(1,6)="has a fear of heights."
	characterInfo$(1,7)="She is a bit faster"
	characterInfo$(1,8)="than her brother and"
	characterInfo$(1,9)="hates being confused"
	characterInfo$(1,10)="with him."

	characterInfo$(2,0)="Jay"
	characterInfo$(2,1)=""
	characterInfo$(2,2)="Jay is one bad dude!"
	characterInfo$(2,3)="Some say he is totally"
	characterInfo$(2,4)="radical, while others"
	characterInfo$(2,5)="think he is just so"
	characterInfo$(2,6)="phat.  Between him and"
	characterInfo$(2,7)="his twin sister Elly,"
	characterInfo$(2,8)="there's always a party"
	characterInfo$(2,9)="in Tetropolis!  He's a"
	characterInfo$(2,10)="little tougher than"
	characterInfo$(2,11)="his sister Elly."

	characterInfo$(3,0)="Esther"
	characterInfo$(3,1)=""
	characterInfo$(3,2)="Esther is an old coot."
	characterInfo$(3,3)="She thinks that all"
	characterInfo$(3,4)="the young piecanoids"
	characterInfo$(3,5)="today have no respect!"
	characterInfo$(3,6)="She is wise but not"
	characterInfo$(3,7)="very strong.  No one"
	characterInfo$(3,8)="knows how she puts up"
	characterInfo$(3,9)="with her smart-alec"
	characterInfo$(3,10)="son, Zee."
	
	characterInfo$(4,0)="Zee"
	characterInfo$(4,1)=""
	characterInfo$(4,2)="Zee has attitude!  He"
	characterInfo$(4,3)="is a know-it-all who"
	characterInfo$(4,4)="don't know nothin'."
	characterInfo$(4,5)="He gets by on his wit"
	characterInfo$(4,6)="and good luck.  You"
	characterInfo$(4,7)="better watch it or"
	characterInfo$(4,8)="he'll get you with a"
	characterInfo$(4,9)="zinger, Zee style!"	

	
	characterInfo$(5,0)="Mr. T"
	characterInfo$(5,1)=""
	characterInfo$(5,2)="Mr. T pities all the"
	characterInfo$(5,3)="fool pitying fools"
	characterInfo$(5,4)="out there!  He is as"
	characterInfo$(5,5)="tough and rough as"
	characterInfo$(5,6)="you can get!  He's"
	characterInfo$(5,7)="bad, mad and in the"
	characterInfo$(5,8)="house.  Have no fear"
	characterInfo$(5,9)="Mr. T is here - to "
	characterInfo$(5,10)="C-O-L-L-E-C-T!"

	characterInfo$(6,0)="Blocky"
	characterInfo$(6,1)=""
	characterInfo$(6,2)="Blocky is Mr. T's"
	characterInfo$(6,3)="pet Blockdog!  His"
	characterInfo$(6,4)="bark is worse than"
	characterInfo$(6,5)="his bite, though.  He"
	characterInfo$(6,6)="is a lovable pooch"
	characterInfo$(6,7)="everyone plays with."
	characterInfo$(6,8)="Linus gets mad when he"
	characterInfo$(6,9)="plays fetch with him"
	characterInfo$(6,10)="because he really"
	characterInfo$(6,11)="plays fetch with him!"

End Function			
Function fonttext(x,y,a$,idiotfont)	;draw the font images in the specified image font
	For i=0 To Len(a$)
		r$=Mid$(a$,i+1,1)
		b=Asc(r$)

		If (b>=32 And b<=126)	
			DrawImage idiotfont,x+(cpos),y,b-32
			If (b>=65 And b<=90) Or (b>=48 And b<=57) Then cpos=cpos+25 Else cpos=cpos+20

		EndIf

	Next ;i

End Function
Function centerx(a$)	;center the bigfont horizontally based on the length of a$

	For i=0 To Len(a$)
		r$=Mid$(a$,i+1,1)
		b=Asc(r$)

		If (b>=32 And b<=126)	
			If (b>=65 And b<=90) Or (b>=48 And b<=57) Then cpos=cpos+25 Else cpos=cpos+20
		EndIf

	Next ;i

	l=400-((cpos)/2)

	Return l
End Function
Function controlkey()
	If KeyDown(29) Or KeyDown(157) Then Return 1
End Function
Function shiftkey()
	If  KeyDown(42) Or KeyDown(54) Then Return 1
End Function


.titleText
Data 0,1,1,1,1,1,1,1,1,0,0,2,2,2,2,2,2,2,2,0,0,3,3,3,3,3,3,3,3,0,0,4,4,4,4,4,4,4,0,0,0,5,5,5,5,5,5,5,5,0,0,0,6,6,6,6,6,6,6,0
Data 0,1,1,1,1,1,1,1,1,0,0,2,2,2,2,2,2,2,2,0,0,3,3,3,3,3,3,3,3,0,0,4,4,4,4,4,4,4,4,0,0,5,5,5,5,5,5,5,5,0,0,6,6,6,6,6,6,6,6,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,0,0,0,4,4,0,0,0,0,0,5,5,0,0,0,0,0,6,6,0,0,0,0,0,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,0,0,0,4,4,0,0,0,0,0,5,5,0,0,0,0,0,6,6,0,0,0,0,0,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,0,5,5,0,0,0,0,0,6,6,6,6,6,6,0,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,4,4,4,4,4,0,0,0,0,0,0,5,5,0,0,0,0,0,0,6,6,6,6,6,6,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,4,4,4,0,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,0,0,0,6,6,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,0,4,4,4,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,0,0,0,6,6,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,0,0,4,4,4,0,0,5,5,5,5,5,5,5,5,0,0,6,6,6,6,6,6,6,0,0
Data 0,0,0,0,1,1,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,3,3,0,0,0,0,0,4,4,0,0,0,0,4,4,0,0,5,5,5,5,5,5,5,5,0,0,6,6,6,6,6,6,0,0,0

.pieceDefs
;line piece
Data 0,1,0,0
Data 0,1,0,0
Data 0,1,0,0
Data 0,1,0,0

;L piece
Data 0,0,0,0
Data 0,2,0,0
Data 0,2,0,0
Data 0,2,2,0

;J piece
Data 0,0,0,0
Data 0,3,0,0
Data 0,3,0,0
Data 3,3,0,0

;S piece
Data 0,0,0,0
Data 4,0,0,0
Data 4,4,0,0
Data 0,4,0,0

;Z piece
Data 0,0,0,0
Data 0,0,5,0
Data 0,5,5,0
Data 0,5,0,0

;T piece
Data 0,0,0,0
Data 0,0,0,0
Data 6,6,6,0
Data 0,6,0,0

;block piece
Data 0,0,0,0
Data 0,0,0,0
Data 0,7,7,0
Data 0,7,7,0